<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--
GAC proyecto SNC
@author 		david.cifuentes
@version 		2.0
@description	Pantalla de detalle de documentos aportados y por aportar, y de ampliación de tiempos.
@cu 			CU-CO-R-01

-->

<h:panelGrid xmlns="http://www.w3.org/1999/xhtml"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:f="http://java.sun.com/jsf/core"
             xmlns:h="http://java.sun.com/jsf/html"
             xmlns:fn="http://java.sun.com/jsp/jstl/functions"
             xmlns:p="http://primefaces.org/ui" columns="1" cellspacing="3"
             width="100%" id="asociarDocumentosYAmpliarTiemposPanelGrid">

    <p:messages id="msgAsociarDoc" showDetail="false" globalOnly="false" />

    <h:form id="asociarDocumentosYAmpliarTiemposForm"
            onkeypress="return event.keyCode != 13;">

        <p:spacer height="20" width="0" />

        <p:tabView cache="true" dynamic="true" id="asociarDocumentosTabView">

            <p:ajax event="tabChange"
                    listener="#{managedBeanParam.onTabChange}" update=":asociarDocumentosYAmpliarTiemposForm:asociarDocumentosTabView"/>

            <p:tab title="Asociar documentos" id="asociarDocsPnlGrd">

                <h:panelGrid columns="4"
                             columnClasses="colPequena, colMediana, colPequena, colMediana"
                             cellspacing="7">
                    <h:outputLabel value="Número de solicitud: "
                                   styleClass="outputLabelStyle" />
                    <p:commandLink styleClass="commandLinkStyle"
                                   oncomplete="detalleSolicitudEjecutarWV.show();"
                                   update=":msgAsociarDoc, :detalleSolicitudEjecutarForm">
                        <h:outputText
                            value="#{managedBeanParam.tramiteSeleccionado.solicitud.numero}"
                            styleClass="outputTextStyle" />
                        <f:setPropertyActionListener
                            value="#{managedBeanParam.tramiteSeleccionado.solicitud}"
                            target="#{vistaDetallesSolicitud.solicitudSeleccionada}" />
                    </p:commandLink>

                    <h:outputLabel value="Fecha de solicitud: "
                                   styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{managedBeanParam.tramiteSeleccionado.solicitud.fecha}"
                        styleClass="outputTextStyle">
                        <f:convertDateTime pattern="#{general.formatoFecha}" />
                    </h:outputText>

                    <h:outputLabel value="Número de radicación: "
                                   styleClass="outputLabelStyle" />
                    <p:commandLink styleClass="commandLinkStyle"
                                   oncomplete="detalleTramiteEjecutarWV.show();"
                                   update=":detalleTramiteEjecutarForm"
                                   title="click para ver detalles del trámite"
                                   rendered="#{managedBeanParam.tramiteSeleccionado.numeroRadicacion != null
                                               and not empty managedBeanParam.tramiteSeleccionado.numeroRadicacion }">
                        <h:outputText
                            value="#{managedBeanParam.tramiteSeleccionado.numeroRadicacion}"
                            styleClass="outputTextStyle" />
                        <f:setPropertyActionListener
                            value="#{managedBeanParam.tramiteSeleccionado}"
                            target="#{vistaDetallesTramite.selectedTramiteForDetailsChecking}" />
                    </p:commandLink>

                    <h:outputText value="No tiene"
                                  rendered="#{managedBeanParam.tramiteSeleccionado.numeroRadicacion == null
                                              or managedBeanParam.tramiteSeleccionado.numeroRadicacion eq ''}"
                                  styleClass="outputTextStyle" />

                    <h:outputLabel value="Fecha de radicación: "
                                   styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{managedBeanParam.tramiteSeleccionado.fechaRadicacion}"
                        styleClass="outputTextStyle">
                        <f:convertDateTime pattern="#{general.formatoFecha}" />
                    </h:outputText>

                    <h:outputLabel value="Tipo de trámite: "
                                   styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{managedBeanParam.tramiteSeleccionado.tipoTramiteCadenaCompleto}"
                        styleClass="outputTextStyle" />

                </h:panelGrid>

                <p:spacer height="20" width="1" />

                <p:tabView dynamic="true" id="tabViewDocumentacion">

                    <p:tab title="Resumen de documentación">

                        <p:dataTable var="documentacionTramite"
                                     rowKey="#{documentacionTramite.id}" id="tblDocumentacionTramite"
                                     widgetVar="documentosRequeridosWV" paginatorPosition="bottom"
                                     paginator="true" rows="10"
                                     value="#{managedBeanParam.documentacionTramite}"
                                     paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                     rowsPerPageTemplate="5,10,15"
                                     emptyMessage="No hay resultados para esta búsqueda">

                            <p:column>
                                <f:facet name="header">
                                    Aportado
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.aporta ? 'Si' : 'No'}" />
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Radicado en  <br />
                                    correspondencia
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.documentoSoporte.fechaRadicacion}">
                                    <f:convertDateTime pattern="#{general.formatoFecha}" />
                                </h:outputText>
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Fecha de  <br />
                                    correspondencia
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.documentoSoporte.fechaDocumento}">
                                    <f:convertDateTime pattern="#{general.formatoFecha}" />
                                </h:outputText>
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Tipo documento
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.tipoDocumento.nombre}" />
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Detalle
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.detalle}" />
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Folios
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.cantidadFolios}" />
                            </p:column>
                            <p:column>
                                <f:facet name="header">
                                    Documento soporte
                                </f:facet>
                                <p:commandLink
                                    value="#{documentacionTramite.documentoSoporte.archivo}"
                                    update=":docViewer:docViewerCCForm"
                                    styleClass="commandLinkStyle"
                                    oncomplete="docViewerWV.show();statusDialog2.hide()"
                                    onstart="statusDialog2.show()"
                                    action="#{managedBeanParam.cargarDocumentoTemporalPrev}"
                                    rendered="#{!documentacionTramite.documentoSoporte.archivoADescargar}">
                                    <f:setPropertyActionListener
                                        target="#{previsualizacionDocumento.documentoGeneral}"
                                        value="#{documentacionTramite.documentoSoporte}" />
                                    <f:setPropertyActionListener
                                        target="#{managedBeanParam.documentoSeleccionado}"
                                        value="#{documentacionTramite}" />
                                </p:commandLink>
                            </p:column>
                            <p:column>
                                <f:facet name="header">
                                    Digitalizable
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentacionTramite.digital}" />
                            </p:column>

                        </p:dataTable>
                    </p:tab>

                    <p:tab title="Documentación requerida">

                        <p:dataTable var="documentoRequerido" id="tblDocumentosRequeridos"
                                     widgetVar="documentosRequeridosWV" paginatorPosition="bottom"
                                     paginator="true" rows="10" rowKey="#{documentoRequerido.id}"
                                     value="#{managedBeanParam.documentacionRequerida}"
                                     paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                     rowsPerPageTemplate="5,10,15"
                                     emptyMessage="No hay resultados para esta búsqueda">
                            <p:column>
                                <f:facet name="header">
                                    Opciones
                                </f:facet>
                                <p:commandButton update=":documentacionForm, :msgsDoc"
                                                 oncomplete="documentacionWV.show()" immediate="true"
                                                 id="editarDocumentacion" icon="ui-icon ui-icon-pencil"
                                                 title="Editar"
                                                 action="#{managedBeanParam.setupDocumentoRequeridoEdicion}">
                                    <f:setPropertyActionListener value="#{documentoRequerido}"
                                                                 target="#{managedBeanParam.documentoSeleccionado}" />
                                    <f:setPropertyActionListener value="#{documentoRequerido.documentoSoporte.archivo}"
                                                                 target="#{managedBeanParam.rutaMostrar}" />
                                    <f:setPropertyActionListener
                                        target="#{managedBeanParam.editandoDocumentacion}"
                                        value="true" />
                                    <f:setPropertyActionListener
                                        target="#{gestionarSolicitudes.banderaDocumentosFaltantes}"
                                        value="true" />
                                    <f:setPropertyActionListener
                                        target="#{managedBeanParam.banderaMostrarNumeroRadicado}"
                                        value="true" />
                                    <f:setPropertyActionListener value="false"
                                                                 target="#{managedBeanParam.documentoSoporteEliminado}" />
                                </p:commandButton>
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Aportado
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentoRequerido.aporta ? 'Si' : 'No'}" />
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Tipo documento
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentoRequerido.tipoDocumento.nombre}" />
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Detalle
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentoRequerido.detalle}" />
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Folios
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentoRequerido.cantidadFolios}" />
                            </p:column>
                            <p:column>
                                <f:facet name="header">
                                    Documento soporte
                                </f:facet>
                                <p:commandLink
                                    value="#{documentoRequerido.documentoSoporte.archivo}"
                                    update=":docViewer:docViewerCCForm"
                                    styleClass="commandLinkStyle"
                                    oncomplete="docViewerWV.show();statusDialog2.hide()"
                                    onstart="statusDialog2.show()"
                                    action="#{managedBeanParam.cargarDocumentoTemporalPrev}"
                                    rendered="#{!documentoRequerido.documentoSoporte.archivoADescargar}">
                                    <f:setPropertyActionListener
                                        target="#{previsualizacionDocumento.documentoGeneral}"
                                        value="#{documentoRequerido.documentoSoporte}" />
                                    <f:setPropertyActionListener
                                        target="#{managedBeanParam.documentoSeleccionado}"
                                        value="#{documentoRequerido}" />
                                </p:commandLink>
                            </p:column>

                            <p:column>
                                <f:facet name="header">
                                    Digitalizable
                                </f:facet>
                                <h:outputText styleClass="outputTextStyle"
                                              value="#{documentoRequerido.digital}" />
                            </p:column>

                        </p:dataTable>
                    </p:tab>

                    <p:tab title="Documentación adicional">

                        <h:panelGrid columns="1" width="100%">

                            <p:commandButton
                                action="#{managedBeanParam.adicionarDocumentoAdicional}"
                                id="nuevoDocumentoAdicional" widgetVar="documentosAdicionalesWV"
                                update="tblDocumentosAdicionales,:documentacionForm,:msgsDoc,:documentacionForm2"
                                value="Nuevo" oncomplete="documentacionWV.show()"
                                icon="ui-icon-document">
                                <f:setPropertyActionListener
                                    target="#{managedBeanParam.banderaMostrarNumeroRadicado}"
                                    value="true" />
                                <f:setPropertyActionListener
                                    target="#{managedBeanParam.editandoDocumentacion}"
                                    value="false" />
                                <f:setPropertyActionListener value="false"
                                                             target="#{managedBeanParam.documentoSoporteEliminado}" />
                            </p:commandButton>
                            <p:spacer height="5"></p:spacer>

                            <p:dataTable var="documentoAdicional"
                                         id="tblDocumentosAdicionales" widgetVar="documentoAdicionalWV"
                                         paginatorPosition="bottom" paginator="true" rows="10"
                                         value="#{managedBeanParam.documentacionAdicional}"
                                         rowKey="#{documentoAdicional.id}"
                                         paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                         rowsPerPageTemplate="5,10,15"
                                         emptyMessage="No hay resultados para esta búsqueda">

                                <p:column>
                                    <f:facet name="header">
                                        Opciones
                                    </f:facet>
                                    <p:commandButton update=":documentacionForm"
                                                     oncomplete="documentacionWV.show()"
                                                     id="editarDocumentacionAdicional"
                                                     icon="ui-icon ui-icon-pencil" title="Editar">
                                        <f:setPropertyActionListener value="#{documentoAdicional}"
                                                                     target="#{managedBeanParam.documentoSeleccionado}" />
                                        <f:setPropertyActionListener value="true"
                                                                     target="#{managedBeanParam.editandoDocumentacion}" />
                                        <f:setPropertyActionListener value="false"
                                                                     target="#{managedBeanParam.documentoSoporteEliminado}" />
                                    </p:commandButton>
                                    <p:commandButton
                                        oncomplete="handleCompleteSIC(xhr, status,args, confirmarEliminarDocAdicionalWV, true);"
                                        icon="ui-icon ui-icon-trash" title="Eliminar"
                                        id="eliminarDocumentacionAdicional">
                                        <f:setPropertyActionListener value="#{documentoAdicional}"
                                                                     target="#{managedBeanParam.documentoSeleccionado}" />
                                    </p:commandButton>
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        Tipo documento
                                    </f:facet>
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{documentoAdicional.tipoDocumento.nombre}" />
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        Detalle
                                    </f:facet>
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{documentoAdicional.detalle}" />
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        Folios
                                    </f:facet>
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{documentoAdicional.cantidadFolios}" />
                                </p:column>
                                <p:column>
                                    <f:facet name="header">
                                        Documento soporte
                                    </f:facet>
                                    <p:commandLink
                                        value="#{documentoAdicional.documentoSoporte.archivo}"
                                        update=":docViewer:docViewerCCForm"
                                        styleClass="commandLinkStyle"
                                        oncomplete="docViewerWV.show();statusDialog2.hide()"
                                        onstart="statusDialog2.show()"
                                        action="#{managedBeanParam.cargarDocumentoTemporalPrev}"
                                        rendered="#{!documentoAdicional.documentoSoporte.archivoADescargar}">
                                        <f:setPropertyActionListener
                                            target="#{previsualizacionDocumento.documentoGeneral}"
                                            value="#{documentoAdicional.documentoSoporte}" />
                                        <f:setPropertyActionListener
                                            target="#{managedBeanParam.documentoSeleccionado}"
                                            value="#{documentoAdicional}" />
                                    </p:commandLink>
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        Digitalizable
                                    </f:facet>
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{documentoAdicional.digital}" />
                                </p:column>

                            </p:dataTable>
                        </h:panelGrid>
                    </p:tab>

                </p:tabView>

            </p:tab>

            <p:tab title="Ampliar tiempos" id="ampliarTiemposTab">

                <p:fieldset style="border:0px">
                    <h:panelGrid columns="2" cellspacing="3">
                        <h:panelGrid columns="3" cellspacing="10" cellpadding="10">

                            <h:outputLabel
                                value="Fecha de comunicación de la solicitud de los documentos:"
                                styleClass="outputLabelStyle" />
                            <h:outputText style="width:150px;height:14px;"
                                          value="#{managedBeanParam.fechaComunicacionSolicitud}">
                                <f:convertDateTime
                                    pattern="#{general.formatoFechaComponenteCalendar}" />
                            </h:outputText>

                            <p:spacer height="3" />
                            <h:outputLabel
                                value="Fecha inicial finalización de espera de los documentos:"
                                styleClass="outputLabelStyle" />
                            <h:outputText style="width:150px;height:14px;"
                                          value="#{managedBeanParam.fechaFinalizacionDeEspera}">
                                <f:convertDateTime
                                    pattern="#{general.formatoFechaComponenteCalendar}" />
                            </h:outputText>

                            <p:spacer height="3" />
                            <h:outputLabel
                                value="Tiempo de ampliación de espera de documentos:"
                                styleClass="outputLabelStyle" />
                            <h:panelGrid columns="3">
                                <p:inputText style="width:14px;height:14px;"
                                             id="tiempoAmpliacion"
                                             value="#{managedBeanParam.tiempoAmpliacion}"
                                             label="Tiempo de ampliación de espera de documentos">
                                    <p:ajax event="blur"
                                            update="fechaDeFinalizacion, 
                                            :asociarDocumentosYAmpliarTiemposForm:btnAvanzar, :msgAsociarDoc"
                                            listener="#{managedBeanParam.actualizarFechaDeFinalizacion}" />
                                </p:inputText>
                                <h:outputLabel value=" días." styleClass="outputLabelStyle" />
                                <p:message for="tiempoAmpliacion" display="icon" />
                            </h:panelGrid>

                            <p:spacer height="3" />
                            <h:outputLabel
                                value="Nueva fecha de finalización de espera de documentos:"
                                styleClass="outputLabelStyle" />
                            <h:outputText id="fechaDeFinalizacion"
                                          style="width:150px;height:14px;"
                                          value="#{managedBeanParam.nuevaFechaFinalizacion}">
                                <f:convertDateTime
                                    pattern="#{general.formatoFechaComponenteCalendar}" />
                            </h:outputText>

                        </h:panelGrid>
                        <h:panelGrid columns="2" cellspacing="7" id="docCargaPnlGrd"
                                     columnClasses="colPequena, colGrande">
                            <p:spacer height="3" />
                            <p:fileUpload id="fu" label="Cargar documento"
                                          fileUploadListener="#{managedBeanParam.archivoUploadAmpliarTiempos}"
                                          dragDropSupport="true"
                                          invalidFileMessage="Formato de documento no permitido"
                                          widgetVar="uploader" mode="advanced" auto="true"
                                          allowTypes="/(\.|\/)(pdf|tif|dwg|png|jp[e]?g)$/"
                                          sizeLimit="#{general.maximoTamanoAdjuntos}" update=":msgsDoc, docCargaPnlGrd"
                                          onstart="statusDialog2.show();" disabled="#{managedBeanParam.docAmpliarTiempoRecibido}"
                                          oncomplete="statusDialog2.hide();" />

                            <h:outputLabel value="Documento soporte: " rendered="#{not empty managedBeanParam.rutaMostrar or not empty managedBeanParam.documentoAmpliacionTemp}"
                                           styleClass="outputLabelStyle" />
                            <p:commandLink
                                value="#{managedBeanParam.documentoAmpliacionTemp.documentoSoporte.archivo}"
                                update=":docViewer:docViewerCCForm"
                                styleClass="commandLinkStyle"
                                oncomplete="docViewerWV.show();statusDialog2.hide()"
                                onstart="statusDialog2.show()"
                                action="#{managedBeanParam.cargarDocumentoTemporalPrev}"
                                rendered="#{not empty managedBeanParam.documentoAmpliacionTemp}">
                                <f:setPropertyActionListener
                                    target="#{previsualizacionDocumento.documentoGeneral}"
                                    value="#{managedBeanParam.documentoAmpliacionTemp.documentoSoporte}" />								
                            </p:commandLink>
                            <p:commandLink
                                value="#{managedBeanParam.rutaMostrar}"
                                update=":docViewer:docViewerCCForm"
                                styleClass="commandLinkStyle"
                                oncomplete="docViewerWV.show();statusDialog2.hide()"
                                onstart="statusDialog2.show()"
                                action="#{managedBeanParam.cargarDocumentoTemporalPrev}"
                                rendered="#{empty managedBeanParam.documentoAmpliacionTemp}">
                                <f:setPropertyActionListener
                                    target="#{managedBeanParam.documentoSeleccionado.documentoSoporte.archivo}"
                                    value="#{managedBeanParam.rutaMostrar}" />								
                                <f:setPropertyActionListener
                                    target="#{previsualizacionDocumento.documentoGeneral}"
                                    value="#{managedBeanParam.documentoSeleccionado.documentoSoporte}" />								
                            </p:commandLink>							

                        </h:panelGrid>
                    </h:panelGrid>
                </p:fieldset>
            </p:tab>
        </p:tabView>

        <p:spacer height="7" width="0" />

        <p:outputPanel id="asociarDocumentosPanelButtons" layout="block"
                       style="text-align:right">

            <p:commandButton value="Ver solicitud de documentos"
                             id="btnVerSolicitudDocumentos"
                             update="vistaDeSolicitudDeDocumentosForm" icon="ui-icon-search"
                             rendered="#{managedBeanParam.solicitudDocumentosBool}"
                             oncomplete="vistaDeSolicitudDeDocumentosWV.show();" />

            <p:spacer height="0" width="25" />

            <p:commandButton id="btnGuardar" value="Validar y guardar"
                             icon="ui-icon-disk" title="Valida y guarda los cambios del trámite y su documentación"
                             label="Validar y guardar"
                             update="asociarDocumentosYAmpliarTiemposForm, :msgAsociarDoc, :detalleTramiteEjecutarForm"
                             process="@this, asociarDocumentosYAmpliarTiemposForm"
                             onstart="statusDialog2.show();" 
                             onsuccess="statusDialog2.hide();"
                             action="#{managedBeanParam.guardarTramiteConRecepcionDeDocumentos}" />

            <p:spacer height="0" width="25" />

            <p:commandButton id="btnAvanzar" value="Avanzar proceso"
                             icon="ui-icon-seek-next" title="Avanzar el proceso"
                             label="Avanzar el proceso"
                             disabled="#{!managedBeanParam.avanzarDeRecibirDocumentosBool}"
                             update="asociarDocumentosYAmpliarTiemposForm, :msgAsociarDoc, :asociarDocumentosForm"
                             process="@this, asociarDocumentosYAmpliarTiemposForm"
                             onstart="statusDialog2.show();"
                             oncomplete="statusDialog2.hide();handleCompleteSIC(xhr, status,args, asociarDocumentosYAmpliarTiemposWV, false);"
                             action="#{managedBeanParam.moverProcesoEnRecibirDocumentos}" />

            <p:spacer height="0" width="25" />

            <p:commandButton value="Cerrar" icon="ui-icon-close"
                             action="#{managedBeanParam.deseleccionarTramites}"
                             oncomplete="asociarDocumentosYAmpliarTiemposWV.hide()" ajax="false"
                             immediate="true" />
            <p:spacer height="0" width="25" />

        </p:outputPanel>
        <p:spacer height="20" width="0" />

    </h:form>
</h:panelGrid>